SystemOrganization addCategory: #SeasideAsync!

!WAStandardScripts methodsFor: '*seasideasync' stamp: 'avi 6/30/2005 01:30'!
liveUpdate
	^ 'function liveUpdaterUri(uri)
{
    return liveUpdater(function() { return uri; });
}

function addParameter(uri, key, value)
{
	var separator = "?";

	if(uri.indexOf("?") >= 0)
	    separator = "&";
	return uri + separator + key + "=" + escape(value);
}

function liveUpdater(uriFunc)
{
    var request = false;
    var regex = /<(\w+).*?id="(\w+)".*?>((.|\n)*)<\/\1>/;
    
    if (window.XMLHttpRequest) {
       	request = new XMLHttpRequest();
    }
    

    function update()
    {
       if(request && request.readyState < 4)
            request.abort();
            
        if(!!window.XMLHttpRequest)
            request = new ActiveXObject("Microsoft.XMLHTTP");
        
        request.onreadystatechange = processRequestChange;
        request.open("GET", addParameter(uriFunc(), "timestamp", (new Date()).getTime().toString()));
        request.send(null);
        return false;
    }
    
 function processRequestChange()
   {
       if(request.readyState == 4)
       {
           var results = regex.exec(request.responseText);
           if(results) {
               document.getElementById(results[2]).innerHTML = results[3];
           } else {
                 var bodyRegex = /<body>(.*)?<\/body>/;
                 var body = bodyRegex.exec(request.responseText);
                 if ( body ) {
                     document.body.innerHTML = body[1];
                 } else {
                     document.body.innerHTML = request.responseText;
                 }
           }
       }
   }
    return update;
}

function liveSelect(id, uri)
{
	function constructUri()
	{
		return addParameter(uri, "s", document.getElementById(id).selectedIndex.toString());
	}
	
	return liveUpdater(constructUri); 
}

function liveScroll(id, uri)
{
   function constructUri()
   {
         return addParameter(uri, "s", document.getElementById(id).scrollTop.toString());
   }
   
   var updater = liveUpdater(constructUri);
   var timeout = false;

    function start() {
	   if (timeout)
	       window.clearTimeout(timeout);
	   
    	   timeout = window.setTimeout(updater, 100);
    }
   return start;
}

function liveSearch(id, uri)
{
    function constructUri()
    {
        return addParameter(uri, "s", document.getElementById(id).value);
    }
    
    var updater = liveUpdater(constructUri);
    var last = "";
    var timeout = false;

    function update()
    {
       if (last !!= document.getElementById(id).value)
            updater();
    }
        
    function start() {
	   if (timeout)
	       window.clearTimeout(timeout);
	   
    	   timeout = window.setTimeout(update, 300);
    }

	
	if (navigator.userAgent.indexOf("Safari") > 0)
		document.getElementById(id).addEventListener("keydown",start,false);
    else if (navigator.product == "Gecko")
		document.getElementById(id).addEventListener("keypress",start,false);
    else
		document.getElementById(id).attachEvent("onkeydown",start);
}

function timedUpdate(uriFunc, milliSeconds)
{
	var updater = liveUpdaterUri(uriFunc);
	updater();
	var again = "timedUpdate(\""+uriFunc+"\","+milliSeconds+")";
	setTimeout(again, milliSeconds);
}
'! !

WAComponent subclass: #WACanvasLiveRequestTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync'!

!WACanvasLiveRequestTest methodsFor: 'as yet unclassified' stamp: 'dwj 6/9/2005 15:56'!
initialize
	count _ 0! !

!WACanvasLiveRequestTest methodsFor: 'as yet unclassified' stamp: 'dwj 6/11/2005 06:23'!
renderContentOn: html
	| a |
	html form: [
		html textInput liveCallback: 
			[:text :h | 
			h div id: 'forward'; with:
				[h unorderedList: [text do:
					[:c | 
					h listItem: [ h anchor 
									callback: [self inform: c displayString];
									text: c displayString]]]]]].
	html form: [
		html textInput liveCallback: 
			[:text :h |
			h div id: 'backward'; with: 
				[h unorderedList: 
					[text reverse do: 
						[:c |
						 h listItem: 
							[h anchor 
								callback: [self inform: c displayString];
								text: c displayString]]]]]].
	html form: [
		html select 
			list: #(a b c); 
			selected: #a; 
			labels: [:ea | ea displayString];
			liveCallback: [:item :h | h span id: 'selection'; with: item]].

	a := html anchor. 
	a liveCallback: [:h | h span id: 'time'; with: Time now].
	a text: 'Show time'.
	a callback:[].
	
	
		

	html heading: 'Forward' level: 3.
	html div id: 'forward'; with: ''.
	html heading: 'Backward' level: 3.
	html div id: 'backward'; with: ''.
	html heading: 'Selection' level: 3.
	html span id: 'selection'; with: ''.
	html heading: 'Time' level: 3.
	html span id: 'time'; with: ''.

! !

!WACanvasLiveRequestTest methodsFor: 'as yet unclassified' stamp: 'dwj 6/9/2005 15:59'!
rendererClass
	^ WARenderCanvas! !

!WACanvasLiveRequestTest methodsFor: 'as yet unclassified' stamp: 'dwj 6/9/2005 15:56'!
selection
	^ #a! !

!WACanvasLiveRequestTest methodsFor: 'as yet unclassified' stamp: 'dwj 6/9/2005 15:56'!
selection: anObject! !

WAComponent subclass: #WALiveRequestTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync'!

!WALiveRequestTest methodsFor: 'as yet unclassified' stamp: 'avi 7/23/2004 16:25'!
initialize
	count _ 0! !

!WALiveRequestTest methodsFor: 'as yet unclassified' stamp: 'avi 6/30/2005 01:31'!
renderContentOn: html

	| liveUpdateBlock |
	liveUpdateBlock _ [ :text :h | h text: Time now printString ].
	
	html table: [
		html tableRowWith: [
			html text: 'Current Time in default div:']
		with: [
			html refreshDivWith: liveUpdateBlock every: 2 seconds ].
		
		html tableRowWith: [
			html text: 'Current Time in another div:']
		with: [
			html refreshDivNamed: 'mylivediv' with: liveUpdateBlock every: 3 seconds ].
			
		html tableRowWith: [
			html text: 'Current Time in default span:']
		with: [
			html refreshSpanWith: liveUpdateBlock every: 5 seconds. ].
	].

	html form: [
		html textInputWithCallback: [:v ] liveCallback:
			[:text :h |
			h divNamed: 'forward' with:
				[h list: text do:
					[:c |
					h anchorWithAction: [self inform: c asString] text: c asString]]]
	].

	html form: [
		html textInputWithCallback: [:v ] liveCallback:
			[:text :h |
			h divNamed: 'backward' with:
				[h list: text reverse do:
					[:c |
					h anchorWithAction: [self inform: c asString] text: c asString]]]
	].

	html form: [
		html selectFromList: #(a b c) selected: #a callback: [:v] labels: [:ea | ea asString] liveCallback:
		[:item :h |
		h spanNamed: 'selection' with: item]].
	
	html anchorWithAction: [] liveAction: [:h | h spanNamed: 'time' with: Time now] text: 'Show time'. 
	html break.
	html anchorWithAction: [] liveAction: [:h | h spanNamed: 'time' with: 1/0] text: 'Live error'.
	
	html heading: 'Forward' level: 3.
	html divNamed: 'forward' with: ''.
	html heading: 'Backward' level: 3.
	html divNamed: 'backward' with: ''.
	html heading: 'Selection' level: 3.
	html spanNamed: 'selection' with: ''.
	html heading: 'Time' level: 3.
	html spanNamed: 'time' with: ''.

	html spanNamed: 'scroll' with: ''.
	html scrollbarWithHeight: 100 size: 1000 liveCallback: [:n :h | h spanNamed: 'scroll' with: n]! !

!WALiveRequestTest methodsFor: 'as yet unclassified' stamp: 'avi 9/2/2004 13:11'!
selection
	^ #a! !

!WALiveRequestTest methodsFor: 'as yet unclassified' stamp: 'avi 9/2/2004 13:11'!
selection: anObject! !

!WARenderCanvas methodsFor: '*seasideasync' stamp: 'lr 10/30/2005 00:00'!
urlForLiveRequest: aBlock
	| request text response renderer document |
	request := ResponseContinuation currentDo: [ :cc | 
		^ WACurrentSession value 
			actionUrlForContinuation: cc ].
	text := request at: 's' ifAbsent: [].
	response := WAResponse new.
	renderer := WARenderCanvas 
		context: self context copy
		callbacks: self callbacks.
	document := WAHtmlStreamDocument new
		stream: response stream.
	renderer context document: document.
	aBlock value: text value: renderer.
	document close.
	WACurrentSession value returnResponse: response.! !

!WATextInputTag methodsFor: '*seasideasync' stamp: 'dwj 6/11/2005 07:06'!
liveCallback: aBlock
	| uri id |
	id := self ensureId.
	uri := canvas urlForLiveRequest: aBlock.
	canvas script: 'liveSearch(',id printString,',',uri displayString printString,')'.! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'mbany 4/14/2005 12:32'!
anchorWithAction: actionBlock liveAction: liveBlock text: aString
	| uri id |
	id _ self ensureId.
	self anchorWithAction: actionBlock text: aString.
	uri _ self urlForLiveRequest: [:t :h | liveBlock value: h].
	self script: 'document.getElementById(',id printString,').onclick = liveUpdaterUri(',uri displayString printString, ')'! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'brp 5/8/2005 15:22'!
refreshDivNamed: divName with: liveBlock every: aDuration

	self
		refreshElementNamed: divName
		createElementWith: #divNamed:with:
		with: liveBlock
		every: aDuration
! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'brp 5/8/2005 15:22'!
refreshDivWith: liveBlock every: aDuration
	"Convenience method if you need only one automatically refreshing div on a page."

	self
		refreshDivNamed: 'live_update_div'
		with: liveBlock
		every: aDuration
! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'brp 5/8/2005 15:26'!
refreshElementNamed: elementName createElementWith: aSymbol with: liveBlock every: aDuration
	"Private method to creates an element using aSymbol that executes and displays the result 
	of liveBlock in intervals of aDuration. The interval starts at the end of execution: 
	if liveBlock is time consuming, the next execution will happen aDuration later.
	No overlapping refreshes will occur.
	See #refreshDivWith:every: and refreshSpanWith:"
	
	| uri |
	self perform: aSymbol with: elementName with: [
		uri := self urlForLiveRequest: [ :text :h | 
			h divNamed: elementName with: [ liveBlock value: text value: h ] ].
		self script: 
			'timedUpdate('
			, uri asString printString
			, ', ' , aDuration asMilliSeconds printString
			, ')'
	]
! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'brp 5/8/2005 15:22'!
refreshSpanNamed: spanName with: liveBlock every: aDuration

	self
		refreshElementNamed: spanName
		createElementWith: #spanNamed:with:
		with: liveBlock
		every: aDuration
! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'brp 5/8/2005 15:23'!
refreshSpanWith: liveBlock every: aDuration
	"Convenience method if you need only one automatically refreshing span on a page."

	self
		refreshSpanNamed: 'live_update_span'
		with: liveBlock
		every: aDuration
! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'avi 6/30/2005 01:17'!
scrollbarWithHeight: heightNumber size: sizeNumber liveCallback: liveBlock
	| id uri |
	id _ self ensureId.
	self attributeAt: 'style' put: 'position: relative; left: -3px; width: 19px; overflow: auto; height: ', heightNumber asString, 'px'.
	self div:
		[self attributeAt: 'style' put: 'width: 1px; height: ', sizeNumber asString, 'px'.
		self div: ''].
	uri _ self urlForLiveRequest: [:t :h | liveBlock value: t asInteger value: h].
	self script: 'document.getElementById(', id printString, ').onscroll = liveScroll(', id printString, ', ', uri displayString printString, ')'! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'mbany 4/14/2005 12:33'!
selectFromList: aCollection selected: anObject callback: callbackBlock labels: labelsBlock liveCallback: liveBlock
	| uri id items |
	id _ self ensureId.
	items _ aCollection asArray.
	self selectFromList: items selected: anObject callback: callbackBlock labels: labelsBlock.
	uri _ self urlForLiveRequest: [:index :h | liveBlock value: (items at: index asInteger + 1 ifAbsent: []) value: h].
	self script: 'document.getElementById(',id printString,').onchange = liveSelect(',id printString,',',uri displayString printString,')'
! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'mbany 4/14/2005 12:34'!
selectFromList: aCollection selected: anObject callback: aBlock labels: labelBlock other: otherBlock label: aString
	| id other  |
	id _ 'id', self context advanceKey displayString.
	other _ (self context nextKey asNumber + aCollection size + 1) displayString.
	self attributes onChange: 'if(this.value == ', other printString, ') {document.getElementById(', id printString, ').style.display = "inline"; document.getElementById(', id printString, ').focus()} else {document.getElementById(', id printString, ').style.display = "none"}'.
	self
		selectFromList: (aCollection asArray copyWith: aString)
		selected: anObject
		callback: [:v | v = aString ifFalse: [aBlock value: v]]
		labels: [:ea | ea = aString ifTrue: [aString] ifFalse: [labelBlock value: ea]].
	self space.
	self cssId: id.
	self attributes style: 'display: none'.
	self textInputWithValue: nil callback: [:v | v ifNotNil: [otherBlock value: v]]! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'mbany 4/14/2005 12:34'!
textInputWithCallback: callbackBlock liveCallback: liveBlock
	| uri id |
	id _ self ensureId.
	self textInputWithValue: '' callback: callbackBlock.
	uri _ self urlForLiveRequest: liveBlock.
	self script: 'liveSearch(',id printString,',',uri displayString printString,')'.
	! !

!WAHtmlRenderer methodsFor: '*seasideasync' stamp: 'lr 10/29/2005 23:55'!
urlForLiveRequest: aBlock
	| request text response renderer document |
	request := ResponseContinuation currentDo: [ :cc | 
		^ WACurrentSession value 
			actionUrlForContinuation: cc ].
	text := request at: 's' ifAbsent: [].
	response := WAResponse new.
	renderer := WAHtmlRenderer
		context: self context copy
		callbacks: self callbacks.
	document := WAHtmlStreamDocument new stream: response stream.
	renderer context document: document.
	aBlock value: text value: renderer.
	document close.
	WACurrentSession value returnResponse: response.! !

!WAAnchorTag methodsFor: '*seasideasync' stamp: 'dwj 6/11/2005 06:38'!
liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	uri := canvas urlForLiveRequest: [:t :h | liveBlock value: h].
	self onClick: 'liveUpdaterUri(',uri displayString printString, ')()'! !

!WASelectTag methodsFor: '*seasideasync' stamp: 'dwj 6/10/2005 15:38'!
liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	uri := canvas urlForLiveRequest: [:index :h | liveBlock value: (list at: index asInteger + 1 ifAbsent: []) value: h].
	canvas script: 'document.getElementById(',id printString,').onchange = liveSelect(',id printString,',',uri displayString printString,')'
! !
